#ifndef BINARY_H
#define BINARY_H

typedef unsigned char u_char;

constexpr u_char twoPow(int n) {
    return n > 0 ? 2*twoPow(n-1) : 1;
}

template<char...> struct binaryHelper;

template<char c> struct binaryHelper<c> {
    static_assert(c == '0' || c == '1', "keine Binärziffer");
    static constexpr u_char value() { return c - '0'; }
};

template<char c, char... tail> struct binaryHelper<c, tail...> {
    static_assert(c == '.' || c == '0' || c == '1', "keine Binärziffer");
    static_assert(((sizeof...(tail) + 1) % 5) || c == '.',
                  "die Zahl muss in mit '.' getrennte Viererblöcke unterteilt sein");
    static constexpr u_char value() {
        return (c == '.' ? 0 : (c - '0')*twoPow(sizeof...(tail) - sizeof...(tail)/5))
                + binaryHelper<tail...>::value();
    }
};

template<char... chars> constexpr u_char operator"" _b() {
    return binaryHelper<chars...>::value();
}

#endif // BINARY_H
